pcl::CropHull< PointT > Class Template Reference
Module filters

Filter points that lie inside or outside a 3D closed surface or 2D closed polygon, as generated by the ConvexHull or ConcaveHull classes. More...

`#include <pcl/filters/crop_hull.h>`

Inheritance diagram for pcl::CropHull< PointT >:

## Public Types

typedef boost::shared_ptr< CropHull< PointT > > | Ptr
typedef boost::shared_ptr< const CropHull< PointT > > | ConstPtr
Public Types inherited from pcl::FilterIndices< PointT >
typedef pcl::PointCloud< PointT > | PointCloud
typedef boost::shared_ptr< FilterIndices< PointT > > | Ptr
typedef boost::shared_ptr< const FilterIndices< PointT > > | ConstPtr
Public Types inherited from pcl::Filter< PointT >
typedef boost::shared_ptr< Filter< PointT > > | Ptr
typedef boost::shared_ptr< const Filter< PointT > > | ConstPtr
typedef pcl::PointCloud< PointT > | PointCloud
typedef PointCloud::Ptr | PointCloudPtr
typedef PointCloud::ConstPtr | PointCloudConstPtr
Public Types inherited from pcl::PCLBase< PointT >
typedef pcl::PointCloud< PointT > | PointCloud
typedef PointCloud::Ptr | PointCloudPtr
typedef PointCloud::ConstPtr | PointCloudConstPtr
typedef boost::shared_ptr< PointIndices > | PointIndicesPtr
typedef boost::shared_ptr< PointIndices const > | PointIndicesConstPtr

## Public Member Functions

| CropHull ()
| Empty Constructor. More...
void | setHullIndices (const std::vector< Vertices > &polygons)
| Set the vertices of the hull used to filter points. More...
std::vector< Vertices > | getHullIndices () const
| Get the vertices of the hull used to filter points. More...
void | setHullCloud (PointCloudPtr points)
| Set the point cloud that the hull indices refer to. More...
PointCloudPtr | getHullCloud () const
| Get the point cloud that the hull indices refer to. More...
void | setDim (int dim)
| Set the dimensionality of the hull to be used. More...
void | setCropOutside (bool crop_outside)
| Remove points outside the hull (default), or those inside the hull. More...
Public Member Functions inherited from pcl::FilterIndices< PointT >
| FilterIndices (bool extract_removed_indices=false)
| Constructor. More...
virtual | ~FilterIndices ()
| Empty virtual destructor. More...
void | filter (PointCloud &output)
void | filter (std::vector< int > &indices)
| Calls the filtering method and returns the filtered point cloud indices. More...
void | setNegative (bool negative)
| Set whether the regular conditions for points filtering should apply, or the inverted conditions. More...
bool | getNegative ()
| Get whether the regular conditions for points filtering should apply, or the inverted conditions. More...
void | setKeepOrganized (bool keep_organized)
| Set whether the filtered points should be kept and set to the value given through setUserFilterValue (default: NaN), or removed from the PointCloud, thus potentially breaking its organized structure. More...
bool | getKeepOrganized ()
| Get whether the filtered points should be kept and set to the value given through setUserFilterValue (default = NaN), or removed from the PointCloud, thus potentially breaking its organized structure. More...
void | setUserFilterValue (float value)
| Provide a value that the filtered points should be set to instead of removing them. More...
Public Member Functions inherited from pcl::Filter< PointT >
| Filter (bool extract_removed_indices=false)
| Empty constructor. More...
virtual | ~Filter ()
| Empty destructor. More...
IndicesConstPtr const | getRemovedIndices ()
| Get the point indices being removed. More...
void | getRemovedIndices (PointIndices &pi)
| Get the point indices being removed. More...
void | filter (PointCloud &output)
| Calls the filtering method and returns the filtered dataset in output. More...
Public Member Functions inherited from pcl::PCLBase< PointT >
| PCLBase ()
| Empty constructor. More...
| PCLBase (const PCLBase &base)
| Copy constructor. More...
virtual | ~PCLBase ()
| Destructor. More...
virtual void | setInputCloud (const PointCloudConstPtr &cloud)
| Provide a pointer to the input dataset. More...
PointCloudConstPtr const | getInputCloud () const
| Get a pointer to the input point cloud dataset. More...
virtual void | setIndices (const IndicesPtr &indices)
| Provide a pointer to the vector of indices that represents the input data. More...
virtual void | setIndices (const IndicesConstPtr &indices)
| Provide a pointer to the vector of indices that represents the input data. More...
virtual void | setIndices (const PointIndicesConstPtr &indices)
| Provide a pointer to the vector of indices that represents the input data. More...
virtual void | setIndices (size_t row_start, size_t col_start, size_t nb_rows, size_t nb_cols)
| Set the indices for the points laying within an interest region of the point cloud. More...
IndicesPtr const | getIndices ()
| Get a pointer to the vector of indices used. More...
IndicesConstPtr const | getIndices () const
| Get a pointer to the vector of indices used. More...
const PointT & | operator[] (size_t pos) const
| Override PointCloud operator[] to shorten code. More...

## Protected Member Functions

void | applyFilter (PointCloud &output)
| Filter the input points using the 2D or 3D polygon hull. More...
void | applyFilter (std::vector< int > &indices)
| Filter the input points using the 2D or 3D polygon hull. More...
Protected Member Functions inherited from pcl::Filter< PointT >
const std::string & | getClassName () const
| Get a string representation of the name of this class. More...
Protected Member Functions inherited from pcl::PCLBase< PointT >
bool | initCompute ()
| This method should get called before starting the actual computation. More...
bool | deinitCompute ()
| This method should get called after finishing the actual computation. More...

## Additional Inherited Members

Protected Attributes inherited from pcl::FilterIndices< PointT >
bool | negative_
| False = normal filter behavior (default), true = inverted behavior. More...
bool | keep_organized_
| False = remove points (default), true = redefine points, keep structure. More...
float | user_filter_value_
| The user given value that the filtered point dimensions should be set to (default = NaN). More...
Protected Attributes inherited from pcl::Filter< PointT >
IndicesPtr | removed_indices_
| Indices of the points that are removed. More...
std::string | filter_name_
| The filter name. More...
bool | extract_removed_indices_
| Set to true if we want to return the indices of the removed points. More...
Protected Attributes inherited from pcl::PCLBase< PointT >
PointCloudConstPtr | input_
| The input point cloud dataset. More...
IndicesPtr | indices_
| A pointer to the vector of point indices to use. More...
bool | use_indices_
| Set to true if point indices are used. More...
bool | fake_indices_
| If no set of indices are given, we construct a set of fake indices that mimic the input PointCloud. More...

## Detailed Description

### template<typename PointT>
class pcl::CropHull< PointT >

Filter points that lie inside or outside a 3D closed surface or 2D closed polygon, as generated by the ConvexHull or ConcaveHull classes.

Author
  James Crosby

Definition at line 53 of file crop_hull.h.

## Member Typedef Documentation

template<typename PointT >

typedef boost::shared_ptr< const CropHull<PointT> > pcl::CropHull< PointT >::ConstPtr

Definition at line 66 of file crop_hull.h.

template<typename PointT >

typedef boost::shared_ptr< CropHull<PointT> > pcl::CropHull< PointT >::Ptr

Definition at line 65 of file crop_hull.h.

## Constructor & Destructor Documentation

template<typename PointT >

pcl::CropHull< PointT >::CropHull | ( |  | ) |

inline

Empty Constructor.

Definition at line 69 of file crop_hull.h.

References pcl::Filter< PointT >::filter_name_.

## Member Function Documentation

template<typename PointT >

void pcl::CropHull< PointT >::applyFilter | ( | PointCloud & | output | ) |

protected virtual

Filter the input points using the 2D or 3D polygon hull.

Parameters

  [out] | output | The set of points that passed the filter

Implements pcl::FilterIndices< PointT >.

Definition at line 45 of file crop_hull.hpp.

Referenced by pcl::CropHull< PointT >::setCropOutside().

template<typename PointT >

void pcl::CropHull< PointT >::applyFilter | ( | std::vector< int > & | indices | ) |

protected virtual

Filter the input points using the 2D or 3D polygon hull.

Parameters

  [out] | indices | the indices of the set of points that passed the filter.

Implements pcl::FilterIndices< PointT >.

Definition at line 70 of file crop_hull.hpp.

References pcl::PointCloud< PointT >::push_back(), and pcl::Vertices::vertices.

template<typename PointT >

PointCloudPtr pcl::CropHull< PointT >::getHullCloud | ( |  | ) | const

inline

Get the point cloud that the hull indices refer to.

Definition at line 107 of file crop_hull.h.

template<typename PointT >

std::vector<Vertices> pcl::CropHull< PointT >::getHullIndices | ( |  | ) | const

inline

Get the vertices of the hull used to filter points.

Definition at line 91 of file crop_hull.h.

template<typename PointT >

void pcl::CropHull< PointT >::setCropOutside | ( | bool | crop_outside | ) |

inline

Remove points outside the hull (default), or those inside the hull.

Parameters

  [in] | crop_outside | If true, the filter will remove points outside the hull. If false, those inside will be removed.

Definition at line 129 of file crop_hull.h.

References pcl::CropHull< PointT >::applyFilter().

template<typename PointT >

void pcl::CropHull< PointT >::setDim | ( | int | dim | ) |

inline

Set the dimensionality of the hull to be used.

This should be set to correspond to the dimensionality of the convex/concave hull produced by the pcl::ConvexHull and pcl::ConcaveHull classes.

Parameters

  [in] | dim | Dimensionailty of the hull used to filter points.

Definition at line 119 of file crop_hull.h.

template<typename PointT >

void pcl::CropHull< PointT >::setHullCloud | ( | PointCloudPtr | points | ) |

inline

Set the point cloud that the hull indices refer to.

Parameters

  [in] | points | the point cloud that the hull indices refer to

Definition at line 100 of file crop_hull.h.

template<typename PointT >

void pcl::CropHull< PointT >::setHullIndices | ( | const std::vector< Vertices > & | polygons | ) |

inline

Set the vertices of the hull used to filter points.

Parameters

  [in] | polygons | Vector of polygons (Vertices structures) forming the hull used for filtering points.

Definition at line 83 of file crop_hull.h.

The documentation for this class was generated from the following files:

- /build/pcl-0nnAvv/pcl-1.7.2/filters/include/pcl/filters/crop_hull.h
- /build/pcl-0nnAvv/pcl-1.7.2/filters/include/pcl/filters/impl/crop_hull.hpp